local EPE = {
	Event = {},
	data = {
		enabled = true,
		playerID = "",
		update = false,
		totaldamage = 0,
		recordDPS = 50,
		currentDPS = 0,
		currentPercent = 0.0,
		firstCall = 0.0,
		skin = "cyan.PNG",
		meter_x = 0,
		meter_y = 0,
		
	},
	 
}


local function unitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		EPE.data.enabled = true
		end 
		end 
		end
		
local function unitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		EPE.data.enabled = false
		end 
		end 
		end


function EPE.Event.LoadEnd(handle, identifier)
	if identifier == "Epeen" then
		EPE.data.playerID = Inspect.Unit.Lookup("player")
		
		EPE.data.enabled = true
		print("Epeen loaded. /EPE")
	end
end


function EPE.Event.Damage(handle, info)
if info.damage then
if info.caster == EPE.data.playerID and info.target ~= EPE.data.playerID then
	EPE.data.totaldamage = EPE.data.totaldamage + info.damage
	
end


end
end





function EPE.Event.SlashHandler(handle, str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")
	if cmd == "reset" then
		EPE.data.recordDPS = 50
		print("DPS goal reset to 50")
	elseif cmd == "goal" then
		goal = string.match(arg, "(%d+)")
		if goal then
		EPE.data.recordDPS = tonumber(goal)
		print("Goal has been set to "..goal)
		else
		print("Invalid goal: Must be a number - characters are ignored")
		end
		
	elseif cmd == "skins" then
	open_selection()
	print("Open skin selection tool")
	
	
	else
		print("Slash Commands:")
		print("Use /EPE reset to reset the meter to 50")
		print("Use /EPE goal ### to reset the meter to ###")
		print("(### being an actual number, such as 9001 if your goal is OVER 9000!)")
		print("Use /EPE skins to pull up the skin selection window to change the meter's fill texture")
	end

	EPE.data.update = true
	fade()
end

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	EPE.data.meter_x = x - self.originalXDiff
	EPE.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local mover = UI.CreateFrame("Texture","meter",main)
local meter = UI.CreateFrame("Texture","meter",mover)
local filler = UI.CreateFrame("Mask", "filler",mover)
local fill = UI.CreateFrame("Texture","fill",filler)
local skins = UI.CreateFrame("Frame", "skins", main)

local high = UI.CreateFrame("Text","high",meter)
local current = UI.CreateFrame("Text","current",meter)
local percent = UI.CreateFrame("Text","percent",meter)

mover:SetPoint("CENTER",UIParent,"CENTER",0,-50)
meter:SetPoint("CENTER",UIParent,"CENTER",0,-50)
fill:SetPoint("CENTER",meter,"CENTER",0,0)
filler:SetPoint("BOTTOMLEFT",meter,"BOTTOMLEFT",0,0)
skins:SetPoint("CENTER", UIParent, "CENTER", 0, 0)

high:SetPoint("TOPCENTER",meter,"TOPCENTER",0,-20)
current:SetPoint("BOTTOMCENTER",meter,"BOTTOMCENTER",0,20)
percent:SetPoint("BOTTOMCENTER",meter,"BOTTOMCENTER",50,-50)
	
	skins:SetAlpha(1)
	skins:SetWidth(900)
	skins:SetHeight(300)
	
	meter:SetAlpha(.9)
	meter:SetWidth(105)
	meter:SetHeight(155)
	
	fill:SetWidth(105)
	fill:SetHeight(150)
	fill:SetAlpha(1)
	
	filler:SetWidth(105)
	filler:SetHeight(150)
	
	meter:SetTexture("Epeen", "bg.PNG")
	fill:SetTexture("Epeen", EPE.data.skin)
	
	high:SetText(tostring(EPE.data.recordDPS))
	current:SetText(tostring(EPE.data.currentDPS))
	percent:SetText(tostring(EPE.data.currentPercent).." %")
	
	high:SetFontColor(1,1,1,1)
	current:SetFontColor(1,1,1,1)
	percent:SetFontColor(1,1,1,1)
	
	high:SetAlpha(1)
	current:SetAlpha(1)
	percent:SetAlpha(1)
	
	high:SetFontSize(15)
	current:SetFontSize(15)
	percent:SetFontSize(15)
	
	--set layers and vis
	meter:SetLayer(1)
	meter:SetVisible(true)
	
	fill:SetLayer(0)
	fill:SetVisible(true)

	filler:SetLayer(3)
	
	skins:SetLayer(4)
	--skins:SetBackgroundColor(6,6,6)
	skins:SetVisible(false)
	
	-- skin select
	
	--local skin_name = UI.CreateFrame("Texture","name",skins)
	local skin_blue_armor = UI.CreateFrame("Texture","blue_armor",skins)
	local skin_green = UI.CreateFrame("Texture","green",skins)
	local skin_dark_knight = UI.CreateFrame("Texture","dark_knight",skins)
	local skin_Invader_31 = UI.CreateFrame("Texture","Invader_31",skins)
	local skin_lava = UI.CreateFrame("Texture","lava",skins)
	local skin_multi = UI.CreateFrame("Texture","multi",skins)
	local skin_defiant = UI.CreateFrame("Texture","defiant",skins)
	local skin_guard = UI.CreateFrame("Texture","guard",skins)
	
	local skin_blue_armor_button = UI.CreateFrame("RiftButton","blue_armor_button",skin_blue_armor)
	local skin_green_button = UI.CreateFrame("RiftButton","green_button",skin_green)
	local skin_dark_knight_button = UI.CreateFrame("RiftButton","dark_knight_button",skin_dark_knight)
	local skin_Invader_31_button = UI.CreateFrame("RiftButton","Invader_31_button",skin_Invader_31)
	local skin_lava_button = UI.CreateFrame("RiftButton","lava_button",skin_lava)
	local skin_multi_button = UI.CreateFrame("RiftButton","multi_button",skin_multi)
	local skin_defiant_button = UI.CreateFrame("RiftButton","defiant_button",skin_defiant)
	local skin_guard_button = UI.CreateFrame("RiftButton","guard_button",skin_guard)
	
	local skin_header = UI.CreateFrame("Text", "Skin_header", skins)
--	skin_blue_armor:
--	skin_green:
--	skin_dark_knight:
--	skin_Invader_31:
--	skin_lava:
--	skin_multi:
--skin_defiant:
--skin_guard:


	skin_blue_armor:SetTexture("Epeen", "blue_armor.PNG")
	skin_green:SetTexture("Epeen", "green.PNG")
	skin_dark_knight:SetTexture("Epeen", "dark_knight.PNG")
	skin_Invader_31:SetTexture("Epeen", "Invader_31.PNG")
	skin_lava:SetTexture("Epeen", "lava.PNG")
	skin_multi:SetTexture("Epeen", "multi.PNG")
	skin_defiant:SetTexture("Epeen", "defiant.PNG")
	skin_guard:SetTexture("Epeen", "guard.PNG")

	skin_blue_armor:SetLayer(5)
	skin_green:SetLayer(5)
	skin_dark_knight:SetLayer(5)
	skin_Invader_31:SetLayer(5)
	skin_lava:SetLayer(5)
	skin_multi:SetLayer(5)
	skin_defiant:SetLayer(5)
	skin_guard:SetLayer(5)
	
	skin_header:SetLayer(5)
	
	skin_blue_armor_button:SetLayer(5)
	skin_green_button:SetLayer(5)
	skin_dark_knight_button:SetLayer(5)
	skin_Invader_31_button:SetLayer(5)
	skin_lava_button:SetLayer(5)
	skin_multi_button:SetLayer(5)
	skin_defiant_button:SetLayer(5)
	skin_guard_button:SetLayer(5)

	skin_header:SetPoint("CENTER", skins, "CENTER", 0,-160)
	skin_header:SetFontSize(20)
	skin_header:SetFontColor(0,3,0)
	skin_header:SetText("Pick a skin for your Epeen")
	
	skin_blue_armor:SetPoint("CENTER", UIParent, "CENTER", -50, -50)
	skin_green:SetPoint("CENTER", UIParent, "CENTER", -150, -50)
	skin_dark_knight:SetPoint("CENTER", UIParent, "CENTER", -250, -50)
	skin_Invader_31:SetPoint("CENTER", UIParent, "CENTER", 50, -50)
	skin_lava:SetPoint("CENTER", UIParent, "CENTER", 150, -50)
	skin_multi:SetPoint("CENTER", UIParent, "CENTER", 250, -50)
	skin_defiant:SetPoint("CENTER", UIParent, "CENTER", -350, -50)
	skin_guard:SetPoint("CENTER", UIParent, "CENTER", 350, -50)
	
	skin_blue_armor_button:SetPoint("CENTER",skin_blue_armor, "CENTER", 0, 90)
	skin_green_button:SetPoint("CENTER", skin_green, "CENTER", 0, 90)
	skin_dark_knight_button:SetPoint("CENTER", skin_dark_knight, "CENTER", 0, 90)
	skin_Invader_31_button:SetPoint("CENTER", skin_Invader_31, "CENTER", 0, 90)
	skin_lava_button:SetPoint("CENTER", skin_lava, "CENTER", 0, 90)
	skin_multi_button:SetPoint("CENTER", skin_multi, "CENTER", 0, 90)
	skin_defiant_button:SetPoint("CENTER", skin_defiant, "CENTER", 0, 90)
	skin_guard_button:SetPoint("CENTER", skin_guard, "CENTER", 0, 90)

	skin_blue_armor:SetAlpha(1)
	skin_green:SetAlpha(1)
	skin_dark_knight:SetAlpha(1)
	skin_Invader_31:SetAlpha(1)
	skin_lava:SetAlpha(1)
	skin_multi:SetAlpha(1)
	skin_defiant:SetAlpha(1)
	skin_guard:SetAlpha(1)

	
	
	skin_blue_armor:SetWidth(105)
	skin_green:SetWidth(105)
	skin_dark_knight:SetWidth(105)
	skin_Invader_31:SetWidth(105)
	skin_lava:SetWidth(105)
	skin_multi:SetWidth(105)
	skin_defiant:SetWidth(105)
	skin_guard:SetWidth(105)

	skin_blue_armor_button:SetWidth(50)
	skin_green_button:SetWidth(50)
	skin_dark_knight_button:SetWidth(50)
	skin_Invader_31_button:SetWidth(50)
	skin_lava_button:SetWidth(50)
	skin_multi_button:SetWidth(50)
	skin_defiant_button:SetWidth(50)
	skin_guard_button:SetWidth(50)
	
	
	skin_blue_armor:SetHeight(150)
	skin_green:SetHeight(150)
	skin_dark_knight:SetHeight(150)
	skin_Invader_31:SetHeight(150)
	skin_lava:SetHeight(150)
	skin_multi:SetHeight(150)
	skin_defiant:SetHeight(150)
	skin_guard:SetHeight(150)

	skin_blue_armor:SetVisible(true)
	skin_green:SetVisible(true)
	skin_dark_knight:SetVisible(true)
	skin_Invader_31:SetVisible(true)
	skin_lava:SetVisible(true)
	skin_multi:SetVisible(true)
	skin_defiant:SetVisible(true)
	skin_guard:SetVisible(true)

	

	--- 2.0 skins
	local skin_cyan = UI.CreateFrame("Texture","cyan",skins)
	local skin_blood = UI.CreateFrame("Texture","blood",skins)
	local skin_orange = UI.CreateFrame("Texture","orange",skins)
	local skin_white = UI.CreateFrame("Texture","white",skins)
	local skin_pink = UI.CreateFrame("Texture","pink",skins)
	
	--2.0 buttons
	local skin_cyan_button = UI.CreateFrame("RiftButton","cyan_button",skin_cyan)
	local skin_blood_button = UI.CreateFrame("RiftButton","blood_button",skin_blood)
	local skin_orange_button = UI.CreateFrame("RiftButton","orange_button",skin_orange)
	local skin_white_button = UI.CreateFrame("RiftButton","white_button",skin_white)
	local skin_pink_button = UI.CreateFrame("RiftButton","pink_button",skin_pink)
	
	--cyan
	skin_cyan:SetTexture("Epeen", "cyan.PNG")
	skin_cyan:SetLayer(5)
	skin_cyan_button:SetLayer(5)
	skin_cyan:SetPoint("CENTER", UIParent, "CENTER", -250, 140)
	skin_cyan_button:SetPoint("CENTER",skin_cyan, "CENTER", 0, 90)
	skin_cyan:SetAlpha(1)
	skin_cyan:SetWidth(105)
	skin_cyan_button:SetWidth(50)
	skin_cyan:SetHeight(150)
	skin_cyan:SetVisible(true)
	
	--blood
	skin_blood:SetTexture("Epeen", "blood.PNG")
	skin_blood:SetLayer(5)
	skin_blood_button:SetLayer(5)
	skin_blood:SetPoint("CENTER", UIParent, "CENTER", -150, 140)
	skin_blood_button:SetPoint("CENTER",skin_blood, "CENTER", 0, 90)
	skin_blood:SetAlpha(1)
	skin_blood:SetWidth(105)
	skin_blood_button:SetWidth(50)
	skin_blood:SetHeight(150)
	skin_blood:SetVisible(true)
	
	--orange
	skin_orange:SetTexture("Epeen", "orange.PNG")
	skin_orange:SetLayer(5)
	skin_orange_button:SetLayer(5)
	skin_orange:SetPoint("CENTER", UIParent, "CENTER", -50, 140)
	skin_orange_button:SetPoint("CENTER",skin_orange, "CENTER", 0, 90)
	skin_orange:SetAlpha(1)
	skin_orange:SetWidth(105)
	skin_orange_button:SetWidth(50)
	skin_orange:SetHeight(150)
	skin_orange:SetVisible(true)
	
	--white
	skin_white:SetTexture("Epeen", "white.PNG")
	skin_white:SetLayer(5)
	skin_white_button:SetLayer(5)
	skin_white:SetPoint("CENTER", UIParent, "CENTER", 50, 140)
	skin_white_button:SetPoint("CENTER",skin_white, "CENTER", 0, 90)
	skin_white:SetAlpha(1)
	skin_white:SetWidth(105)
	skin_white_button:SetWidth(50)
	skin_white:SetHeight(150)
	skin_white:SetVisible(true)
	
	--pink
	skin_pink:SetTexture("Epeen", "pink.PNG")
	skin_pink:SetLayer(5)
	skin_pink_button:SetLayer(5)
	skin_pink:SetPoint("CENTER", UIParent, "CENTER", 150, 140)
	skin_pink_button:SetPoint("CENTER",skin_pink, "CENTER", 0, 90)
	skin_pink:SetAlpha(1)
	skin_pink:SetWidth(105)
	skin_pink_button:SetWidth(50)
	skin_pink:SetHeight(150)
	skin_pink:SetVisible(true)
	
	
	
	
	--skin button funcs
	function close_selection()
	skins:SetVisible(false)
	end
	
	function open_selection()
	skins:SetVisible(true)
	end
	
	function skin_blue_armor_button.Event:LeftPress()
	EPE.data.skin = "blue_armor.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
	
	function skin_green_button.Event:LeftPress()
	EPE.data.skin = "green.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_dark_knight_button.Event:LeftPress()
	EPE.data.skin = "dark_knight.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_Invader_31_button.Event:LeftPress()
	EPE.data.skin = "Invader_31.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_lava_button.Event:LeftPress()
	EPE.data.skin = "lava.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_multi_button.Event:LeftPress()
	EPE.data.skin = "multi.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_defiant_button.Event:LeftPress()
	EPE.data.skin = "defiant.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	function skin_guard_button.Event:LeftPress()
	EPE.data.skin = "guard.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
		close_selection()
	end
	
	
	--2.0 selections
	
	function skin_cyan_button.Event:LeftPress()
	EPE.data.skin = "cyan.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
	
		function skin_blood_button.Event:LeftPress()
	EPE.data.skin = "blood.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
		function skin_orange_button.Event:LeftPress()
	EPE.data.skin = "orange.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
		function skin_white_button.Event:LeftPress()
	EPE.data.skin = "white.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
		function skin_pink_button.Event:LeftPress()
	EPE.data.skin = "pink.PNG"
	fill:SetTexture("Epeen", EPE.data.skin)
	close_selection()
	end
--end frames

local lastCall = Inspect.Time.Real()
AddDragFrame(meter)
local function combatstart(handle)
EPE.data.firstCall = Inspect.Time.Real()
EPE.data.update = true
end

local function combatend(handle)
EPE.data.update = false
EPE.data.totaldamage = 0
if EPE.data.currentDPS > EPE.data.recordDPS then

EPE.data.recordDPS = EPE.data.currentDPS
end
end

function fade(handle)
if EPE.data.update and EPE.data.enabled then
local now = Inspect.Time.Real()
	if (now<lastCall+.10) then 
		return
	end
EPE.data.currentDPS = EPE.data.totaldamage / (now - EPE.data.firstCall)
EPE.data.currentPercent = EPE.data.currentDPS / EPE.data.recordDPS
local h = math.min(math.floor(150 * EPE.data.currentPercent),150)
filler:SetHeight(h)
	high:SetText(tostring(math.floor(EPE.data.recordDPS)))
	current:SetText(tostring(math.floor(EPE.data.currentDPS)))
	percent:SetText(tostring(math.floor(EPE.data.currentPercent * 100)).." %")
lastCall = now
end
end

local function EPEsave(handle)
 epeen_recordDPS = EPE.data.recordDPS
 	 
epeen_meter_x = EPE.data.meter_x
epeen_meter_y = EPE.data.meter_y
epeen_skin = EPE.data.skin
   end


local function EPEload(handle)
if epeen_recordDPS then
	EPE.data.recordDPS = epeen_recordDPS
	else
	EPE.data.recordDPS = 50
	end

if epeen_meter_x then
EPE.data.meter_x = tonumber(epeen_meter_x)
end

if epeen_meter_y then
 EPE.data.meter_y = tonumber(epeen_meter_y)
 end
 if epeen_skin then
 EPE.data.skin = epeen_skin
 else EPE.data.skin = "cyan.PNG"
end
EPE.data.update = true
fade()
meter:ClearAll()
mover:SetPoint("TOPLEFT", UIParent, "TOPLEFT", EPE.data.meter_x, EPE.data.meter_y)
meter:SetPoint("TOPLEFT", UIParent, "TOPLEFT", EPE.data.meter_x, EPE.data.meter_y)
meter:SetWidth(105)
meter:SetHeight(155)
fill:SetVisible(true)
fill:SetTexture("Epeen", EPE.data.skin)

   end


	--table.insert(Event.System.Update.Begin, {fade, "Epeen", "fade"})
--table.insert(Event.Addon.SavedVariables.Save.Begin, {EPEsave, "Epeen", "Save variables"})
--table.insert(Event.Addon.SavedVariables.Load.Begin, {EPEload, "Epeen", "Load variables"})
--table.insert(Event.Addon.Load.End, 				{EPE.Event.LoadEnd, 			"Epeen", "Init"})
--table.insert(Command.Slash.Register("EPE"), 		{EPE.Event.SlashHandler, 	"Epeen", "Slash"})

--2.5 prep
Command.Event.Attach(Event.Unit.Availability.Full, unitAvailable, "unitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, unitNotAvailable, "unitNotAvailable")

Command.Event.Attach(Event.System.Update.Begin, fade, "fade")

Command.Event.Attach(Event.Combat.Damage, EPE.Event.Damage, "Handle Damage")
Command.Event.Attach(Event.System.Secure.Enter, combatstart, "combatstart")
Command.Event.Attach(Event.System.Secure.Leave, combatend, "combatend")

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, EPEsave, "Save variables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, EPEload, "Load variables")
Command.Event.Attach(Event.Addon.Load.End, EPE.Event.LoadEnd, "Init")
Command.Event.Attach(Command.Slash.Register("EPE"), EPE.Event.SlashHandler, "Slash")








